function getSTK() {        //获取股票信息
    if (text != "") {
        var j = 0;          //数组下标
        var fn = text.toString().length;
        stk = [];

        ctx.fillStyle = "RGB(242,242,242)";
        ctx.fillRect(btnX - btnR - 4, 18 + (5 + height * 0.13), width * 2, (5 + height * 0.13) * 5 + 2 * btnR);
        fillText_(ctx, btnX - btnR, 20 + (5 + height * 0.13), width * 1.6, height * 0.13, btnR, "查询匹配股票...", gray);
        if (!isNaN(text)) { //按键精灵 按数字
            stk = [];
            for (var i = 0; i < allStk.length; i++) {
                if (fn > 1) {
                    if ((allStk[i].c.substr(0, fn)).indexOf(text.toString()) != -1 || (allStk[i].c.substr(6 - fn, fn)).indexOf(text.toString()) != -1) {
                        stk.push(allStk[i]);
                        j++;
                        if (j == 5) {
                            break;
                        }
                    }
                } else if (fn == 1) {
                    if ((allStk[i].c.substr(0, fn)).indexOf(text.toString()) != -1) {
                        stk.push(allStk[i]);
                        j++;
                        if (j == 5) {
                            break;
                        }
                    }
                }
            }
        } else {        //按字母     
            stk = [];
            for (var i = 0; i < allStk.length; i++) {
                if ((decodeURI(allStk[i].p).substr(0, fn)).indexOf(text.toUpperCase()) != -1) {
                    stk.push(allStk[i]);
                    j++;
                    if (j == 5) {
                        break;
                    }
                }
            }
        }

        ctx.fillStyle = "RGB(242,242,242)";
        ctx.fillRect(btnX - btnR - 4, 18 + (5 + height * 0.13), width * 2, (5 + height * 0.13) * 5 + 2 * btnR);

        if (stk.length > 0) {
            //roundRect_(ctx, btnX - btnR, 25 + height * 0.13, width * 1.6, height * 0.13 * 5.5, btnR, "", white, black);
            for (var i = 0; i < 5; i++) {
                if (i < stk.length) {
                    val_ = stk[i].c + " " + stk[i].n + " " + stk[i].m;

                    fillText_(ctx, btnX - btnR + width * 0.25, 25 + (5 + height * 0.13) * (i + 1), width * 0.4, height * 0.13, btnR, stk[i].c, black);
                    fillText_(ctx, btnX - btnR + width * 0.7, 25 + (5 + height * 0.13) * (i + 1), width * 0.4, height * 0.13, btnR, stk[i].n, black);
                    fillText_(ctx, btnX - btnR + width * 1.05, 25 + (5 + height * 0.13) * (i + 1), width * 0.4, height * 0.13, btnR, stk[i].m, black);

                    ctx.beginPath();
                    ctx.strokeStyle = gray;
                    ctx.lineWidth = 1;
                    ctx.moveTo(btnX - btnR, 20 + (5 + height * 0.13) * (i + 2));
                    ctx.lineTo(width * 2, 20 + (5 + height * 0.13) * (i + 2));

                    ctx.closePath();
                    ctx.stroke();
                }
            }
        }
    }
}

var getStkN = 0;
function getStk_1(market) {
    showloading();
    $.ajax({
        type: "post",
        url: "data/data.aspx?action=getStk&StockMark=" + market + "&userid=" + userid + "&token=" + token,
        async: true,
        dataType: "json",
        jsonp: "callbackparam",//服务端用于接收callback调用的function名的参数
        jsonpCallback: "success_jsonpCallback",//callback的function名称
        beforeSend: function (XMLHttpRequest) {

        },
        success: function (data, textStatus) {
            for (var i = 0; i < data.TableInfo.length; i++) {
                allStk.push(data.TableInfo[i]);
            }
        },
        complete: function (XMLHttpRequest, textStatus) {
            getStkN++;
            if (getStkN == 3) {
                getStkN = 0;
                hideloading();
                if ((touchID > 0 && touchID < 4) || touchID == 9) {
                    getInside();
                } else if (touchID == 0) {

                    getZXG();
                } else {
                    getSort();
                }
            }
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            //alert(errorThrown);
        }
    });
}

function getSTK_all() {        //获取股票信息
    getStk_1("SH");
    getStk_1("SZ");
    getStk_1("STB");
}

function getInside_() {
    $.ajax({
        type: "post",
        url: "data/data.aspx?action=inside&StockCode=" + stkCode + "&StockMark=" + market,
        async: false,
        dataType: "json",
        beforeSend: function (XMLHttpRequest) {
        },
        success: function (data, textStatus) {
            quote = data.inS[0];
            stkName = quote.stkName;
            preClose = quote.preClose;
        },
        complete: function (XMLHttpRequest, textStatus) {
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
        }
    });
}

function getInside() {
    showloading();
    $.ajax({
        type: "post",
        url: "data/data.aspx?action=inside&StockCode=" + stkCode + "&StockMark=" + market,
        async: true,
        cache: false,
        dataType: "json",
        beforeSend: function (XMLHttpRequest) {

        },
        success: function (data, textStatus) {
            quote = data.inS[0];

            stkName = quote.stkName;
            ltag = quote.ltag;                           //流通股
            preClose = parseFloat(quote.preClose);
            price = parseFloat(quote.price);

            high = parseFloat(quote.high).toFixed(2);
            low = parseFloat(quote.low).toFixed(2);

            if (parseFloat(quote.open) == 0 || price == 0) {
                zdf = "0.00%";
                zd = "0.00";
                price = preClose;
                high = preClose;
                low = preClose;
            }

            zdf = ((price - preClose) * 100 / preClose).toFixed(2) + "%";
            zf_ = (price - preClose) * 100 / preClose;
            zd = (price - preClose).toFixed(2);

            maxP = parseFloat(quote.price) + 0.01;
            minP = parseFloat(quote.price) - 0.01;
            maxF = (price - preClose) * 100 / preClose + 0.01;
            minF = (price - preClose) * 100 / preClose - 0.01;
            //inside();
        },
        complete: function (XMLHttpRequest, textStatus) {
            showloading();
            //alert(touchID);
            if (touchID == 1) {
                getMData();
            }
            else if (touchID == 2) {
                getKData();
            }
            else if (touchID == 3 || touchID == 9) {
                getZJLData();
            }
            hideloading();
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
        }
    });
}

function getMData_() {
    $.ajax({
        type: "post",
        url: "data/data.aspx?action=minInterface&StockCode=" + stkCode + "&StockMark=" + market,
        async: false,
        cache: false,
        dataType: "text", //json
        beforeSend: function (XMLHttpRequest) {
        },
        success: function (data, textStatus) {
            var min = data.split("|");
            var minp_ = [];
            mins = [];
            for (var i = 1; i < min.length; i++) {
                minp_ = min[i].split(",");
                if (min[i].indexOf("0.000,0.000,0") != -1 && i > 1) {
                    for (var n = 1; n < 5; n++) {
                        if (i >= n && min[i - n].indexOf("0.000,0.000,0") == -1) {
                            minp_ = min[i - n].split(",");
                            break;
                        } else if (i <= n) {
                            minp_ = min[i - 1].split(",");
                            break;
                        }
                    }
                    if (min[i].indexOf("0.000,0.000,0") != -1) {
                        minp_ = min[i].split(",");
                    }
                }

                var minj = {
                    mins: 0,
                    price: 0,
                    avgPrice: 0,
                    vol: 0
                };
                if (minp_.length >= 4) {
                    minj.mins = minp_[0];
                    minj.price = minp_[1];
                    minj.avgPrice = minp_[2];
                    minj.vol = minp_[3];
                    mins.push(minj);
                }
            }

        },
        complete: function (XMLHttpRequest, textStatus) {
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
        }
    });
}


function getMData() {
    $.ajax({
        type: "post",
        url: "data/data.aspx?action=minInterface&StockCode=" + stkCode + "&StockMark=" + market,
        async: false,
        cache: false,
        dataType: "text", //json
        beforeSend: function (XMLHttpRequest) {
            showloading();
        },
        success: function (data, textStatus) {
            var min = data.split("|");
            var minp_ = [];
            mins = [];
            for (var i = 1; i < min.length; i++) {
                minp_ = min[i].split(",");
                if (min[i].indexOf("0.000,0.000,0") != -1 && i > 1) {
                    for (var n = 1; n < 5; n++) {
                        if (i >= n && min[i - n].indexOf("0.000,0.000,0") == -1) {
                            minp_ = min[i - n].split(",");
                            break;
                        } else if (i <= n) {
                            minp_ = min[i - 1].split(",");
                            break;
                        }
                    }
                    if (min[i].indexOf("0.000,0.000,0") != -1) {
                        minp_ = min[i].split(",");
                    }
                }

                var minj = {
                    mins: 0,
                    price: 0,
                    avgPrice: 0,
                    vol: 0
                };
                if (minp_.length >= 4) {
                    minj.mins = minp_[0];
                    minj.price = minp_[1];
                    minj.avgPrice = minp_[2];
                    minj.vol = minp_[3];
                    mins.push(minj);
                }
            }
            if (touchID == 1) {
                drawMInterface();
                drawBTN();
                addEventListener();
            }
        },
        complete: function (XMLHttpRequest, textStatus) {
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
        }
    });
}

function getKData() {
    $.ajax({
        type: "post",
        url: "data/data.aspx?action=KInterface&StockCode=" + stkCode + "&StockMark=" + market,
        async: false,
        cache: false,
        dataType: "json",
        beforeSend: function (XMLHttpRequest) {
            showloading();
        },
        success: function (data, textStatus) {
            quote = data.inS[0];

            kl = data.Kl;

            if (kl[kl.length - 1].data == kl[kl.length - 2].data) {
                kl.pop();
            }

            stkName = quote.stkName;
            ltag = quote.ltag;                           //流通股
            preClose = parseFloat(quote.preClose);
            price = parseFloat(quote.price);
            zdf = ((price - preClose) * 100 / preClose).toFixed(2) + "%";
            zd = (price - preClose).toFixed(2);

            high = parseFloat(quote.high).toFixed(2);
            low = parseFloat(quote.low).toFixed(2);

            if (parseInt(quote.open) == 0) {
                zdf = "0.00%";
                zd = "0.00";
                price = preClose;
                high = preClose;
                low = preClose;
            }

            if (touchID == 2) {
                drawKInterface();
                drawBTN();
                addEventListener();
            }
        },
        complete: function (XMLHttpRequest, textStatus) {

        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            getKData1();
        }
    });
}

function getKData1() {
    getKData();
}

function getZJLData() {
    $.ajax({
        type: "post",
        url: "data/data.aspx?action=ZJLInterface&StockCode=" + stkCode + "&StockMark=" + market,
        async: false,
        cache: false,
        timeout: 7000,
        dataType: "json",
        beforeSend: function (XMLHttpRequest) {
        },
        success: function (data, textStatus) {
            quote = data.inS[0];

            zb = data.zb;
            stkName = quote.stkName;
            ltag = quote.ltag;                           //流通股
            preClose = parseFloat(quote.preClose);
            price = parseFloat(quote.price);
            zdf = ((price - preClose) * 100 / preClose).toFixed(2) + "%";
            zd = (price - preClose).toFixed(2);

            high = parseFloat(quote.high).toFixed(2);
            low = parseFloat(quote.low).toFixed(2);

            if (parseInt(quote.open) == 0) {
                zdf = "0.00%";
                zd = "0.00";
                price = preClose;
                high = preClose;
                low = preClose;
            }

            if (touchID == 3) {

                zjl();
            }
            else if (touchID == 9) {
                clbtnid = 4;
                pkBG();
            }
            drawBTN();
            addEventListener();
        },
        complete: function (XMLHttpRequest, textStatus) {
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            getZJLData1();
        }
    });
}

function getZJLData1() {
    getZJLData();
}

function getZXGD(zxgStr) {
    try {
        if (userid == "" && phoneNum == "") {
            if (zxg.length == 1) {
                database.addData("stkList", zxgStr, zxgcallback_add);
            } else if (zxg.length > 1) {
                database.updateData("stkList", zxgStr, zxgcallback_update);
            }
        }
    } catch (e) {
        //alert(e.message);
    }


    $.ajax({
        type: "post",
        url: "data/data.aspx?action=showZXG&StockCode=" + zxgStr,
        async: true,
        //cache: false,
        dataType: "json",
        beforeSend: function (XMLHttpRequest) {

        },
        success: function (data, textStatus) {
            zxg = data.TableInfo;
        },
        complete: function (XMLHttpRequest, textStatus) {
            hideloading();
            if (touchID == 0) {
                drawZXG();
                drawBTN();
                addEventListener();
            }
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {

        }
    });
}

function getZXG() {
    showloading();
    if (userid == "" && phoneNum == "") {
        if (ids != []) {
            zxgStr = ids;
        } else {
            zxgStr = [];
            for (var i = 0; i < zxg.length; i++) {
                zxgStr.push(zxg[i].Stock + "." + zxg[i].market);
            }
        }
        getZXGD(zxgStr);
    } else {
        $.ajax({
            type: "post",
            url: "data/data.aspx?action=getStkList&userid=" + userid + "&phoneNum=" + phoneNum,
            async: true,
            dataType: "json",
            beforeSend: function (XMLHttpRequest) {

            },
            success: function (data, textStatus) {
                if (data.header.errorCode == "000000") {
                    zxgStr = data.body;
                    getZXGD(zxgStr);
                }
            },
            complete: function (XMLHttpRequest, textStatus) {

            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {

            }
        });
    }
}

function addZXG() {
    showloading();
    if (userid == "" && phoneNum == "") {

        if (ids.length > 0) {
            zxgStr = ids;
        } else {
            zxgStr = [];
            for (var i = 0; i < zxg.length; i++) {
                zxgStr.push(zxg[i].Stock + "." + zxg[i].market);
            }
        }



        getZXGD(zxgStr);
    } else {
        $.ajax({
            type: "post",
            url: "data/data.aspx?action=updataStkList&userid=" + userid + "&phoneNum=" + phoneNum + "&mod=addstockcode&StockCode=" + zxg[zxg.length - 1].Stock,
            async: true,
            dataType: "json",
            beforeSend: function (XMLHttpRequest) {

            },
            success: function (data, textStatus) {
                if (data.header.errorCode == "000000") {
                    zxgStr = data.body;
                    getZXGD(zxgStr);
                }
            },
            complete: function (XMLHttpRequest, textStatus) {

            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {

            }
        });
    }
}

function delZXG(stk, mar) {

    showloading();
    zxgStr = [];

    if (userid == "" && phoneNum == "") {
        if (ids.length > 0) {
            zxgStr = ids;
        } else {
            zxgStr = [];
            for (var i = 0; i < zxg.length; i++) {
                zxgStr.push(zxg[i].Stock + "." + zxg[i].market);
            }
        }
        getZXGD(zxgStr);
    } else {
        $.ajax({
            type: "post",
            url: "data/data.aspx?action=updataStkList&userid=" + userid + "&phoneNum=" + phoneNum + "&mod=delstockcode&StockCode=" + stk + "." + mar,
            async: true,
            dataType: "json",
            beforeSend: function (XMLHttpRequest) {

            },
            success: function (data, textStatus) {
                if (data.header.errorCode == "000000") {
                    zxgStr = data.body;
                    getZXGD(zxgStr);
                }
            },
            complete: function (XMLHttpRequest, textStatus) {

            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {

            }
        });
    }
}

function getSort() {
    if (lbtn[clbtnid] == "A股涨幅排名") {
        type = "120";
    } else if (lbtn[clbtnid] == "A股跌幅排名") {
        type = "121";
    } else if (lbtn[clbtnid] == "指数涨幅排名") {
        type = "122";
    } else if (lbtn[clbtnid] == "指数跌幅排名") {
        type = "123";
    }

    $.ajax({
        type: "post",
        url: "data/data.aspx?action=sort&type=" + type,
        async: true,
        cache: false,
        dataType: "json",
        beforeSend: function (XMLHttpRequest) {
        },
        success: function (data, textStatus) {
            sortarr = data.TableInfo;
            if (touchID > 4 && touchID < 9) {
                drawSort();
                drawBTN();
            }
            if (stkCode == "120" || stkCode == "121") {
                stkCode = sortarr[0].c;
                stkName = decodeURI(sortarr[0].n);
                market = sortarr[0].m;
                getInside();
            }
        },
        complete: function (XMLHttpRequest, textStatus) {
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
        }
    });
}

function todeal(StockCode, StockType, StockMark, TradeType) {
    $.ajax({
        type: "post",
        url: "data?StockCode=" + StockCode + "&StockType=" + StockType + "&StockMark=" + StockMark + "&TradeType =" + TradeType,
        async: true,
        cache: false,
        dataType: "text",
        beforeSend: function (XMLHttpRequest) {
        },
        success: function (data, textStatus) {
        },
        complete: function (XMLHttpRequest, textStatus) {
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            //alert(errorThrown + " : data/?StockCode=" + StockCode + "&StockType=" + StockType + "&StockMark=" + StockMark + "&TradeType =" + TradeType);
        }
    });
}